# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

Name:           fusesource-mvnplugins
Version:        1.12
Release:        1%{?dist}
Epoch:          0
Summary:        FuseSource maven plugins
License:        Apache Software License 2.0
Group:          Development/Java
URL:            http://mvnplugins.fusesource.org/
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:      noarch
Source0:        fusesource-mvnplugins-1.12.tgz
# curl -L -o fusesource-mvnplugins-1.12.tgz https://github.com/chirino/mvnplugins/tarball/mvnplugins-1.12
Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Source3:        jackrabbit-parent-5.pom
Patch0:         fusesource-mvnplugins-pom.patch
Patch1:         fusesource-mvnplugins-linkchecker-pom.patch
Patch2:         fusesource-mvnplugins-graph-ProjectReportMojo.patch
Patch3:         fusesource-mvnplugins-scala-mojo-support-pom.patch

BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven-doxia-tools
BuildRequires:  maven-scala-plugin
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  scala28

Requires:  java >= 0:1.6.0
Requires:  maven2 >= 0:2.0.8
Requires:  scala28

%description
A collection of random yet handy Maven plugins.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q -n chirino-mvnplugins-c4e26a6
cp -p %{SOURCE1} settings.xml
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" settings.xml
%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2
%patch3 -b .sav3

%build
export CLASSPATH=
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p ${MAVEN_REPO_LOCAL}/
mkdir -p ${MAVEN_REPO_LOCAL}/org/apache/jackrabbit/parent/5/
cp %{SOURCE3} ${MAVEN_REPO_LOCAL}/org/apache/jackrabbit/parent/5/parent-5.pom
export MAVEN_SETTINGS=$(pwd)/settings.xml

%{_bindir}/mvn-jpp \
        -e \
        -s ${MAVEN_SETTINGS} \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven.test.failure.ignore=true \
        install javadoc:aggregate

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -m 0644 fuse-javadoc-skin/target/fuse-javadoc-skin-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/
install -m 0644 fuse-jxr-skin/target/fuse-jxr-skin-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/
install -m 0644 maven-graph-plugin/target/maven-graph-plugin-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/
install -m 0644 maven-linkchecker-plugin/target/maven-linkchecker-plugin-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/
install -m 0644 maven-uberize-plugin/target/maven-uberize-plugin-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/
install -m 0644 scala-mojo-support/target/scala-mojo-support-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/

(cd $RPM_BUILD_ROOT%{_javadir}/%{name}
for jar in *-%{version}*.jar; do ln -sf ${jar} `echo ${jar} | sed "s|-%{version}||g"`;done)

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap org.fusesource.mvnplugins mvnplugins %{version} JPP %{name} 
install -m 644 fuse-javadoc-skin/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-fuse-javadoc-skin.pom
%add_to_maven_depmap org.fusesource.mvnplugins fuse-javadoc-skin %{version} JPP/%{name} fuse-javadoc-skin
install -m 644 fuse-jxr-skin/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-fuse-jxr-skin.pom
%add_to_maven_depmap org.fusesource.mvnplugins fuse-jxr-skin %{version} JPP/%{name} fuse-jxr-skin
install -m 644 maven-graph-plugin/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-maven-graph-plugin.pom
%add_to_maven_depmap org.fusesource.mvnplugins maven-graph-plugin %{version} JPP/%{name} maven-graph-plugin
install -m 644 maven-linkchecker-plugin/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-maven-linkchecker.pom
%add_to_maven_depmap org.fusesource.mvnplugins maven-linkchecker %{version} JPP/%{name} maven-linkchecker
install -m 644 maven-uberize-plugin/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-maven-uberize-plugin.pom
%add_to_maven_depmap org.fusesource.mvnplugins maven-uberize-plugin %{version} JPP/%{name} maven-uberize-plugin
install -m 644 scala-mojo-support/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-scala-mojo-support.pom
%add_to_maven_depmap org.fusesource.mvnplugins scala-mojo-support %{version} JPP/%{name} scala-mojo-support

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}/
%{_javadir}/%{name}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/*

%changelog
* Sun Nov 06 2011 Ralph Apel <r.apel@r-apel.de> 0:1.12-1
- first release

